<?php
 
 
 

namespace PhpWA\Protocol\Proto\MessageContextInfo;

use UnexpectedValueException;




class MessageAddonExpiryType
{
    


    const MESSAGE_ADDON_EXPIRY_TYPE_UNSPECIFIED = 0;
    


    const PBSTATIC = 1;
    


    const DEPENDENT_ON_PARENT = 2;

    private static $valueToName = [
        self::MESSAGE_ADDON_EXPIRY_TYPE_UNSPECIFIED => 'MESSAGE_ADDON_EXPIRY_TYPE_UNSPECIFIED',
        self::PBSTATIC => 'STATIC',
        self::DEPENDENT_ON_PARENT => 'DEPENDENT_ON_PARENT',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            $pbconst =  __CLASS__. '::PB' . strtoupper($name);
            if (!defined($pbconst)) {
                throw new UnexpectedValueException(sprintf(
                        'Enum %s has no value defined for name %s', __CLASS__, $name));
            }
            return constant($pbconst);
        }
        return constant($const);
    }
}

